hw/arm/sbsa-ref: Remove unnecessary check for secure_sysmem == NULL
[qemu/ar7.git] / tests / qemu-iotests / 063
blobfe4892e4679857bbeb57b8ad5ab874e675ae85ee
1 #!/usr/bin/env bash
3 # test of qemu-img convert -n - convert without creation
5 # Copyright (C) 2009 Red Hat, Inc.
6 # Copyright (C) 2013 Alex Bligh (alex@alex.org.uk)
8 # This program is free software; you can redistribute it and/or modify
9 # it under the terms of the GNU General Public License as published by
10 # the Free Software Foundation; either version 2 of the License, or
11 # (at your option) any later version.
13 # This program is distributed in the hope that it will be useful,
14 # but WITHOUT ANY WARRANTY; without even the implied warranty of
15 # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
16 # GNU General Public License for more details.
18 # You should have received a copy of the GNU General Public License
19 # along with this program. If not, see <http://www.gnu.org/licenses/>.
22 # creator
23 owner=alex@alex.org.uk
25 seq=`basename $0`
26 echo "QA output created by $seq"
28 status=1 # failure is the default!
30 _cleanup()
32 _cleanup_test_img
33 rm -f "$TEST_IMG.orig" "$TEST_IMG.raw1" "$TEST_IMG.raw2"
35 trap "_cleanup; exit \$status" 0 1 2 3 15
37 # get standard environment, filters and checks
38 . ./common.rc
39 . ./common.filter
40 . ./common.pattern
42 _supported_fmt qcow qcow2 vmdk qed raw
43 _supported_proto file
44 _unsupported_imgopts "subformat=monolithicFlat" \
45 "subformat=twoGbMaxExtentFlat" \
46 "subformat=twoGbMaxExtentSparse"
48 _make_test_img 4M
50 echo "== Testing conversion with -n fails with no target file =="
51 # check .orig file does not exist
52 rm -f "$TEST_IMG.orig"
53 if $QEMU_IMG convert -f $IMGFMT -O $IMGFMT -n "$TEST_IMG" "$TEST_IMG.orig" >/dev/null 2>&1; then
54 exit 1
57 echo "== Testing conversion with -n succeeds with a target file =="
58 rm -f "$TEST_IMG.orig"
59 cp "$TEST_IMG" "$TEST_IMG.orig"
60 if ! $QEMU_IMG convert -f $IMGFMT -O $IMGFMT -n "$TEST_IMG" "$TEST_IMG.orig" ; then
61 exit 1
64 echo "== Testing conversion to raw is the same after conversion with -n =="
65 # compare the raw files
66 if ! $QEMU_IMG convert -f $IMGFMT -O raw "$TEST_IMG" "$TEST_IMG.raw1" ; then
67 exit 1
70 if ! $QEMU_IMG convert -f $IMGFMT -O raw "$TEST_IMG.orig" "$TEST_IMG.raw2" ; then
71 exit 1
74 if ! cmp "$TEST_IMG.raw1" "$TEST_IMG.raw2" ; then
75 exit 1
78 echo "== Testing conversion back to original format =="
79 if ! $QEMU_IMG convert -f raw -O $IMGFMT -n "$TEST_IMG.raw2" "$TEST_IMG" ; then
80 exit 1
82 _check_test_img
84 echo "== Testing conversion to a smaller file fails =="
85 rm -f "$TEST_IMG.orig"
86 mv "$TEST_IMG" "$TEST_IMG.orig"
87 _make_test_img 2M
88 if $QEMU_IMG convert -f $IMGFMT -O $IMGFMT -n "$TEST_IMG.orig" "$TEST_IMG" >/dev/null 2>&1; then
89 exit 1
92 echo "== Regression testing for copy offloading bug =="
94 _make_test_img 1M
95 TEST_IMG="$TEST_IMG.target" _make_test_img 1M
96 $QEMU_IO -c 'write -P 1 0 512k' -c 'write -P 2 512k 512k' "$TEST_IMG" | _filter_qemu_io
97 $QEMU_IO -c 'write -P 4 512k 512k' -c 'write -P 3 0 512k' "$TEST_IMG.target" | _filter_qemu_io
98 $QEMU_IMG convert -n -O $IMGFMT "$TEST_IMG" "$TEST_IMG.target"
99 $QEMU_IMG compare "$TEST_IMG" "$TEST_IMG.target"
101 echo "*** done"
102 rm -f $seq.full
103 status=0
104 exit 0